<?php

namespace Teknisa\SM\Controller;

use Teknisa\SM\Controller\SMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\SM\Service\Sm00015000ApropriacaoRecursosService;


class Sm00015000ApropriacaoRecursosController extends SMCrud {
    
    protected $dataSourceName = "fct_apropagendamento_widget";
    protected $apropriacaoService;

    public function __construct($crudService, $environment,Sm00015000ApropriacaoRecursosService $apropriacaoService) {
        parent::__construct($crudService, $environment);
        $this->apropriacaoService  = $apropriacaoService;
    }
    /**
     * Atualizando no banco o campo da tabela de apropriação com as
     * horas que foram excluidas ou adicionadas
     */
    
   public function atualizarQtdHorasApropriadas(Request $request, Response $response){
        try {
            $row = $request->getRow();
            $nrapropagendamento = $row["NRAPROPAGENDAMENTO"];
            $nrorg = $row["NRORG"];
           
            $this->apropriacaoService->atualizarQtdHorasApropriadas($nrapropagendamento,$nrorg);
            $dados = $this->apropriacaoService->getQtdHorasApropriadas($nrapropagendamento,$nrorg);
            $response->addDataSet(new DataSet("dados" , $dados));
            
        }
        catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
   }
   /**
     * Atualizando no banco o campo da tabela de apropriação com as
     * horas que foram excluidas ou adicionadas
     */
    
   public function atualizarSituacaoDoRecurso(Request $request, Response $response){
        try {
            $row = $request->getRow();
            $nrapropagendamento = $row["NRAPROPAGENDAMENTO"];
            $nrorg = $row["NRORG"];
           
            $this->apropriacaoService->atualizarSituacaoDoRecurso($nrapropagendamento,$nrorg);
            $dados = $this->apropriacaoService->getSituacaoDoApontamento($nrapropagendamento,$nrorg);
            $response->addDataSet(new DataSet("dados" , $dados));
            
        }
        catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
   }
}
?>