<?php

namespace Teknisa\SM\Util\Procedure;

use Doctrine\DBAL\Connection;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class CriaMnemonico {
    
    const NOME = "CRIA_MNEMONICO";
    private $connection;
    
    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }
    
    /**
     * Executa a procedure.
     * 
     * @param integer $nrorg
     * @param string $idorcacontr
     * @param integer $nrseq
     * 
     * @return string
     */
    public function executar($nrorg, $idorcacontr, $nrseq) {
        $procedure = new StoredProcedure($this->connection, self::NOME);
        
        $procedure->addParam(new Param("P_NRORG",       Param::PARAM_INPUT,     $nrorg,         Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_IDORCACONTR", Param::PARAM_INPUT,     $idorcacontr,   Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_NRSEQ",       Param::PARAM_INPUT,     $nrseq,         Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_MNEMONICO",   Param::PARAM_OUTPUT,    null,           Param::PARAM_TYPE_STR, 50));
        
        $resultado = $procedure->execute();
        return $resultado["P_MNEMONICO"];
    }
    
}

?>